import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.*;

import javax.swing.*;

import java.awt.*;

public class GradientsOutlines extends JApplet implements MouseListener {
	JButton strokeButton, c1Button, c2Button;
	JPanel toolPanel, drawPanel;

	Color sColor, c1, c2;

	BasicStroke[] strokes;

	Point mousePoint;

	Shape circleShape;

	// Inits our components; adds ActionListeners etc.
	public void init() {
		strokeButton.setText("Stroke Colour");
		strokeButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				Color tempColor = JColorChooser.showDialog(c1Button,
						"Pick Colour 1", c1);
				if (tempColor != null) {
					sColor = tempColor;
				}
			}
		});

		c1Button.setText("Colour 1");
		c1Button.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				Color tempColor = JColorChooser.showDialog(c1Button,
						"Pick Colour 1", c1);
				if (tempColor != null) {
					c1 = tempColor;
				}

			}
		});

		c2Button.setText("Colour 2");
		c2Button.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				Color tempColor = JColorChooser.showDialog(c2Button,
						"Pick Colour 2", c2);
				if (tempColor != null) {
					c2 = tempColor;
				}

			}
		});

		toolPanel.add(strokeButton);
		toolPanel.add(c1Button);
		toolPanel.add(c2Button);

		drawPanel.addMouseListener(this);

		this.add(toolPanel, BorderLayout.NORTH);
		this.add(drawPanel, BorderLayout.CENTER);

	}

	// Sets up our line strokes to be different.
	private void setUpStrokes() {
		float[] pattern1 = { 10.0f };
		strokes = new BasicStroke[3];
		strokes[0] = new BasicStroke();
		strokes[1] = new BasicStroke(5.0f, BasicStroke.CAP_BUTT,
				BasicStroke.JOIN_MITER, 10.0f, pattern1, 0.0f);
		strokes[2] = new BasicStroke();
	}

	public GradientsOutlines() {
		super();
		toolPanel = new JPanel();
		drawPanel = new JPanel();
		toolPanel.setBackground(Color.BLUE);
		strokeButton = new JButton();
		c1Button = new JButton();
		c2Button = new JButton();
		c1 = c2 = Color.RED;
		sColor = Color.BLACK;

		mousePoint = new Point(0, 0);
		circleShape = new Ellipse2D.Double(0, 0, 0, 0);

		setUpStrokes();
	}

	@Override
	public void paint(Graphics g) {
		super.paintComponents(g);
		Graphics2D g2 = (Graphics2D) g;
		g2.setStroke(strokes[0]);
		GradientPaint gp = new GradientPaint(circleShape.getBounds().x,
				circleShape.getBounds().y, c1, circleShape.getBounds().x
						+ circleShape.getBounds().width,
				circleShape.getBounds().y + circleShape.getBounds().height, c2);
		g2.setPaint(gp);
		g2.fill(circleShape);
		g2.setColor(sColor);
		g2.draw(circleShape);
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		mousePoint = e.getPoint();
		circleShape = new Ellipse2D.Double(mousePoint.x, mousePoint.y + 35, 60,
				60);
		repaint();
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
	}

	public static void main(String[] args) {
		GradientsOutlines app = new GradientsOutlines();
		JFrame frame = new JFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().add(app);
		app.init();
		app.start();
		frame.setSize(500, 500);
		frame.setTitle("Gradients and Outlines");
		Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation(screen.width / 2 - frame.getWidth(), screen.height
				/ 2 - frame.getHeight());
		frame.setVisible(true);
	}
}
